image: docker:stable

services:
  - docker:dind

variables:
  DOCKER_DRIVER: overlay2
  PRIVATE_REG: "docker.smartgeosystems.com"
  IMAGE_BUILDER: "geokaskad-dataflow-builder"
  IMAGE_PROD: "geokaskad-dataflow-prod"

before_script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker login -u $PRIVATE_REG_USER -p $PRIVATE_REG_TOKEN $PRIVATE_REG

build_master:
  stage: build
  script:
    # 1.20-3.17
    # Public
    - docker build --pull --no-cache -t $CI_REGISTRY_IMAGE/$IMAGE_BUILDER:1.20-3.17 --build-arg "BASE_IMAGE=golang:1.20.2-alpine3.17" common/builder
    - docker push $CI_REGISTRY_IMAGE/$IMAGE_BUILDER:1.20-3.17

    - docker build --pull --no-cache -t $CI_REGISTRY_IMAGE/$IMAGE_PROD:1.20-3.17 --build-arg "BASE_IMAGE=alpine:3.17" common/prod
    - docker push $CI_REGISTRY_IMAGE/$IMAGE_PROD:1.20-3.17


    # Private
    - docker build --pull --no-cache -t $PRIVATE_REG/$IMAGE_BUILDER:1.20-3.17 --build-arg "BASE_IMAGE=$PRIVATE_REG/golang:1.20.2-alpine3.17" common/builder
    - docker push $PRIVATE_REG/$IMAGE_BUILDER:1.20-3.17

    - docker build --pull --no-cache -t $PRIVATE_REG/$IMAGE_PROD:1.20-3.17 --build-arg "BASE_IMAGE=$PRIVATE_REG/alpine:3.17" common/prod
    - docker push $PRIVATE_REG/$IMAGE_PROD:1.20-3.17

    # 1.22-3.19
    # Public
    - docker build --pull --no-cache -t $CI_REGISTRY_IMAGE/$IMAGE_BUILDER:1.22-3.19 --build-arg "BASE_IMAGE=golang:1.22.0-alpine3.19" common/builder
    - docker push $CI_REGISTRY_IMAGE/$IMAGE_BUILDER:1.22-3.19

    - docker build --pull --no-cache -t $CI_REGISTRY_IMAGE/$IMAGE_PROD:1.22-3.19 --build-arg "BASE_IMAGE=alpine:3.19" common/prod
    - docker push $CI_REGISTRY_IMAGE/$IMAGE_PROD:1.22-3.19


    # Private
    - docker build --pull --no-cache -t $PRIVATE_REG/$IMAGE_BUILDER:1.22-3.19 --build-arg "BASE_IMAGE=$PRIVATE_REG/golang:1.22.0-alpine3.19" common/builder
    - docker push $PRIVATE_REG/$IMAGE_BUILDER:1.22-3.19

    - docker build --pull --no-cache -t $PRIVATE_REG/$IMAGE_PROD:1.22-3.19 --build-arg "BASE_IMAGE=$PRIVATE_REG/alpine:3.19" common/prod
    - docker push $PRIVATE_REG/$IMAGE_PROD:1.22-3.19

  only:
    - main

build_branches:
  stage: build
  script:
    # 1.20-3.17
    # Public
    - docker build --pull --no-cache -t $CI_REGISTRY_IMAGE/$IMAGE_BUILDER:1.20-3.17-$CI_COMMIT_REF_NAME --build-arg "BASE_IMAGE=golang:1.20.2-alpine3.17" common/builder
    - docker push $CI_REGISTRY_IMAGE/$IMAGE_BUILDER:1.20-3.17-$CI_COMMIT_REF_NAME

    - docker build --pull --no-cache -t $CI_REGISTRY_IMAGE/$IMAGE_PROD:1.20-3.17-$CI_COMMIT_REF_NAME --build-arg "BASE_IMAGE=alpine:3.17" common/prod
    - docker push $CI_REGISTRY_IMAGE/$IMAGE_PROD:1.20-3.17-$CI_COMMIT_REF_NAME


    # Private
    - docker build --pull --no-cache -t $PRIVATE_REG/$IMAGE_BUILDER:1.20-3.17-$CI_COMMIT_REF_NAME --build-arg "BASE_IMAGE=$PRIVATE_REG/golang:1.20.2-alpine3.17" common/builder
    - docker push $PRIVATE_REG/$IMAGE_BUILDER:1.20-3.17-$CI_COMMIT_REF_NAME

    - docker build --pull --no-cache -t $PRIVATE_REG/$IMAGE_PROD:1.20-3.17-$CI_COMMIT_REF_NAME --build-arg "BASE_IMAGE=$PRIVATE_REG/alpine:3.17" common/prod
    - docker push $PRIVATE_REG/$IMAGE_PROD:1.20-3.17-$CI_COMMIT_REF_NAME

  except:
    - main